#include <Ethernet.h>
#include <TinyGPS.h>
TinyGPS gps;
#include <SD.h>
#include <Time.h>
#include <TimeLib.h>
#include <EEPROM.h> 
#include <Streaming.h>  
#include <avr/io.h>
#include <avr/wdt.h>
#define Reset_AVR() wdt_enable(WDTO_30MS); while(1) {} 
#include <OneWire.h>
#include <DallasTemperature.h>
#include <EthernetUdp.h>
#include <EnvironmentCalculations.h>
#include <BME280I2C.h>
#include <Wire.h>
#include <SPI.h>
BME280I2C bme;
int sensorRAIN;
unsigned long data,ttime; 

File root;
EthernetServer server(80);

float lat,lon;
 
String BoolRain;
float temp(NAN), hum(NAN), pres(NAN), dewPoint, Alt, seaLevel;

Sd2Card card;
SdVolume volume;
String readString;
File myFile;
String filename;
const int chipSelect = 4;
char timedata[16];
#define ONE_WIRE_BUS 8
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire); 
int counter;
float temperature = 0;
float humidity = 0;
float Ext_Temp,Int_Temp;
float Pressure = 0;
unsigned long epoch;
int Sync;
String dataString = "";
String LAT,LON;

//################################################ # STATION NAME #################################################
// Fill in the name you want to give to your station
String STATIONNAME = "";

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
// Set the static IP address to use if the DHCP fails to assign
IPAddress ip(192, 168, 3, 90);
//IPAddress gateway(192, 168, 3, 1);
//IPAddress subnet(255, 255, 255, 0);  
IPAddress myDns(193, 206, 115, 20);
 
EthernetClient client;

//register your starterkit on https://opensensemap.org/ and fill in the IDs
//senseBox ID
#define SENSEBOX_ID ""

//Sensor IDs
// Temperature
#define SENSOR1_ID ""
// Pressure
#define SENSOR2_ID ""
// Relative Humidity
#define SENSOR3_ID ""
// Rain
#define SENSOR4_ID ""

//Ethernet-Parameter
char serverOSeM[] = "ingress.opensensemap.org";


void setup() { 
   Serial1.begin(9600);         // Serial1 to connect gps sensor
   pinMode(13, OUTPUT);
   Serial.begin(115200);
   delay(200); //wait for 200ms
   Serial.print("My Name is: ");
   Serial.println(STATIONNAME);
   Serial.println();



   //################################################ #  NETWORK CONFIGURATION - START #################################################
// start the Ethernet connection:
  
  Serial.print("Initializing Network....");
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Failed to configure Ethernet using DHCP");
    // Check for Ethernet hardware present
    if (Ethernet.hardwareStatus() == EthernetNoHardware) {
      Serial.println("Ethernet shield was not found.  Sorry, can't run without hardware. :(");
    }
    if (Ethernet.linkStatus() == LinkOFF) {
      Serial.println("Ethernet cable is not connected.");
    }
    // try to congifure using IP address instead of DHCP:
    Ethernet.begin(mac, ip, myDns);
  } else {
    Serial.print("  DHCP assigned IP ");
    Serial.println(Ethernet.localIP());
  }
  // give the Ethernet shield a second to initialize:
  delay(1000);
  
//  Serial.print("My IP Address is: ");
//  Serial.println(Ethernet.localIP());



  Serial.print("connecting to ");
  Serial.print(serverOSeM);
  Serial.print("...");   
  if (client.connect(serverOSeM, 80)) {
    Serial.println("Connected!");
    Serial.print("connected to ");
    Serial.println(client.remoteIP());Serial.println(); 
    
  }
  else
  {
   Serial.println("OSeM Server Unreachable!");
  }
  delay(2000);
 //  postFloatValue(temp, 1, SENSOR1_ID);   
//################################################ # NETWORK CONFIGURATION - END   #################################################
  
 
   // Open serial communications and wait for port to open:
   Wire.begin();
   while(!bme.begin())
   {
      Serial.println("**Could not find BME280 sensor!");
      break;
   }
   switch(bme.chipModel())
   {
     case BME280::ChipModel_BME280:
       Serial.println("Found BME280 sensor! Success.");
       break;
     case BME280::ChipModel_BMP280:
       Serial.println("Found BMP280 sensor! No Humidity available.");
       break;
     default:
       Serial.println("Found UNKNOWN sensor! Error!");
   }
  sensors.begin();
  
 delay(1000);
    server.begin();
  // Udp.begin(localPort);
  delay(100);
  Serial.print("\nInitializing SD card...");
  if (!SD.begin(chipSelect)) {
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(500);
    digitalWrite(13, HIGH);
    Serial.println("Card failed, or not present");
    // don't do anything more:
    delay(1000);
  }

  delay(2000);
  GPS();

  //#################################################
  // We prepare the string to print by serial and to save in the file
  //#################################################
 
  dataString += String("Sync");
  dataString += "|";
  dataString += String("Time");
   dataString += "|";
   dataString += String("Date");
   dataString += "|";
   dataString += String("Temp");
   dataString += "|"; 
   dataString +=String("Humidity");
   dataString += "|"; 
   dataString +=String("DewPoint");
   dataString += "|"; 
   dataString += String("Ext_Temp");
   dataString += "|";
   dataString += String("Pressure");
   dataString += "|";
   dataString += String("SensRain"); 
   dataString += "|";
   dataString += String("Rain");
   dataString += "|";
   dataString += String("Lat");
   dataString += "|";
   dataString += String("Lon");
   dataString += "|";
   dataString += String("hdop");
   dataString += "|";
   dataString += String("#Sat");
  delay(1000);
  digitalWrite(13, LOW);

  //############################################################
  // if Arduino is not sync by GPS, waiting for a new sync from GPS
  //############################################################

  if (Sync != 0)
  {
    delay(2000);
    Serial.println("Waiting for GPS data to open new file");
    GPS();
  }
  //############################################################
  // Create a new file to save data. the file name is automatic generated taking the epoch time in seconds.
  // In this way, we have a file name made by numbers that increase in time. 
  // All this is valid if we have a sync time from GPS.
  //############################################################

  filename=now(); 
  filename=filename.substring(0,8);
  filename+=".dat";
  //############################################################
  // example of file name: "12345678.dat" 
  //############################################################

  delay(1000);
  Serial.println("");
  root = SD.open("/");
  Serial.println("done!");

 //############################################################
 // We open the file ready to write
 //############################################################

  myFile = SD.open(filename, FILE_WRITE);
  if (myFile) {
    Serial.print("Writing to "); Serial.println(filename);
    //############################################################
    // WRITING DATA IN FILE
    //############################################################
    myFile.println(dataString);

   //############################################################
   //############################################################
      
   // close the file:
    myFile.close();
    Serial.println("done.");
    } 
  else { 
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(100);
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(100);
    digitalWrite(13, HIGH);// if the file didn't open, print an error:
    Serial.print("error opening file: ");
    Serial.println(filename);
    }
}


unsigned long time; 
time_t prevDisplay = 0; //

void loop() {  
 
//  Acquisition Loop 60s  ==> 60000 ms
//#################################################
  delay(60000);  // data acquisition every minutes  [60 * 1000]
//#################################################
  String datastring;
  String header;
  counter++;
  if (counter % 5  == 0) 
  {    
      GPS();
  }
  if (minute() == 0 && hour() == 12)  //  RESET OF ARDUINO at 12:00 #Create a new data file.
  {
    counter == 0;
    Reset_AVR();
  } 
  sensorRAIN = analogRead(A5);
  Serial.print("From Rain Sensor: "); Serial.println(sensorRAIN);
  
  if (sensorRAIN >= 900) 
    {
      Serial.println("  (DRY)");
      BoolRain="DRY";
    }
  else
    {
      Serial.println("  (WET)");
      BoolRain="WET";  
    }
  
  sensors.requestTemperatures(); // Send the command to get temperatures
      /*  Int_Temp = (sensors.getTempCByIndex(0));  
      */
  Ext_Temp = (sensors.getTempCByIndex(0));  
  Serial.print("=======================");
  Serial.println();
  Serial.print("From ds18b20 Ext: ");
  Serial.print(Ext_Temp);
  Serial.println(" *C");
  Serial.println();
  Serial.print("From ds18b20 Int: ");
  Serial.print(Int_Temp);
  Serial.println(" *C");
   
  Serial.print("From BME: ");
  printBME280Data(&Serial); 
  
//********************************************************************************************
//********************************************************************************************
  Serial.println("****** Sending Temperature!!");
  postFloatValue(temp, 1, SENSOR1_ID);                ///////////////////////////////////
  delay(1000);
  Serial.println("****** Sending Humidity!!");
  postFloatValue(hum, 1, SENSOR3_ID);                 ///////////////////////////////////  
  delay(1000);
  Serial.println("****** Sending Pressure!!");
  postFloatValue(pres/100, 1, SENSOR2_ID);            ///////////////////////////////////  
  delay(1000);
  Serial.println("****** Sending %Rain!!");
  postFloatValue((103-sensorRAIN/10), 0, SENSOR4_ID); /////////////////////////////////// 
//********************************************************************************************
//********************************************************************************************

 
  header = "\n"; 
  header += String("Sync");
  header += "|";
  header += String("Time");
  header += "|";
  header += String("Date");
  header += "|";
  header += String("Temp");
  header += "|"; 
  header +=String("Humidity");
  header += "|"; 
  header +=String("DewPoint");
  header += "|"; 
  header += String("Ext_Temp");
  header += "|";
  header += String("Pressure");
  header += "|";
  header += String("SensRain"); 
  header += "|";
  header += String("Rain");
  header += "|";
  header += String("Lat");
  header += "|";
  header += String("Lon");
  header += "|";
  header += String("hdop");
  header += "|";
  header += String("#Sat");
   
  dataString = "\n";   
  dataString += Sync;
  dataString += "|"; 
  dataString += String(hour())+":"+String(minute())+":"+String(second());
  dataString += "|"; 
  dataString += String(month())+"/"+String(day())+"/"+String(year());
  dataString += "|"; 
  dataString += temp;
  dataString += "|"; 
  dataString += hum;
  dataString += "|"; 
  dataString += dewPoint;
  dataString += "|"; 
  dataString += Ext_Temp;
  dataString += "|";
  dataString += pres;
  dataString += "|";
  dataString += sensorRAIN;
  dataString += "|";
  dataString += BoolRain;
  dataString += "|";
  dataString += LAT;
  dataString += "|";
  dataString += LON;
  dataString += "|";
  dataString += gps.hdop();
  dataString += "|";
  dataString += gps.satellites();
  dataString += "||";
  Serial.println(header + dataString);
  
  myFile = SD.open(filename, FILE_WRITE);
  if (myFile) 
  {
    Serial.print("Writing to ");Serial.println(filename);
    myFile.println(dataString);
    // close the file:
    myFile.close();
    Serial.println("done.");
  } 
  else 
  {
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(100);
    digitalWrite(13, HIGH);
    delay(500);
    digitalWrite(13, LOW);
    delay(100);
    digitalWrite(13, HIGH);// if the file didn't open, print an error:
    Serial.print("error opening file: ");
    Serial.println(filename);
  }
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client)  
  {
    Serial.println("new client");
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();    
        if (c == '\n') {
          // send a standard http response header
          if (readString.length() < 100) {
          //store characters to string
            readString += c;
          //Serial.print(c);
          }
         
        } 
        
      }  

      if (client.available()) {
        char c = client.read();
        //read char by char HTTP request
        if (readString.length() < 100) {
          //store characters to string
          readString += c;
          //Serial.print(c);
        }
        //if HTTP request has ended
        if (c == '\n' && currentLineIsBlank) {
          client.println("HTTP/1.1 200 OK"); //send new page
          client.println("Content-Type: text/html");
          client.println();        
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");  
      
          client.println("<center><font size=5 color='blue'>"+STATIONNAME+"</font></center><br>");
          client.println("Station: "+STATIONNAME +"<br>");
          client.print("Date - Time:    "); 
          client.print(String(month())+"/"+String(day())+"/"+String(year()));  client.println(" - "); client.println(String(hour())+":"+String(minute())+":"+String(second()));
          client.println("<br>");
          client.println("<font size='4' color='blue'>External Box</font><br>");
          client.print("External Temperature:  "); client.print(Ext_Temp); client.println(" *C<br>");
          client.print("Rain Sensor:  "); 
          if (sensorRAIN >= 900) 
          {
            client.println("DRY<br>");
          }
          else
          {
            client.println("WET<br>");
          }     
          client.print("Internal Temperature: ");client.print(temp); client.println(" *C<br>");
          client.print("Humidity:     ");client.print(hum); client.println(" %RH<br>");
          client.print("Pressure:     ");client.print(pres); client.println(" Pa<br>");
          client.print("DewPoint      ");client.print(dewPoint); client.println(" *C<br>");
          client.print("Equivalent Sea Level Pressure: ");client.print(seaLevel); client.println(" Pa<br>");   
          client.print("GPS Location: ");client.print("<a href='https://www.google.it/maps/place/");client.print(lat,6); client.print(" N,"); client.println(lon,6); client.print(" E");client.print("'>");client.print(lat,6); client.print(" N,"); client.println(lon,6); client.print(" E");client.print("</a><br>");
          client.print("Altitude:     ");client.print(gps.f_altitude());client.println(" m<br>");
          client.print("HDOP:        ");client.print(gps.hdop());client.println("<br>");
          client.print("File Name:   ");client.println(filename);
          client.print("<br>");
          delay(10);
          //stopping client
          client.stop();
          readString="";   
        }
      }
    }    
    Serial.println("client disconnected");
  }
}

// Print an integer in "00" format (with leading zero),
// followed by a delimiter character to Serial.
// Input value assumed to be between 0 and 99.
void printI00(int val, char delim)
{
  if (val < 10) Serial << '0';
  Serial << _DEC(val);
  if (delim > 0) Serial << delim;
  return;
} 

 

void printBME280Data(Stream* client)
{ 
  BME280::TempUnit tempUnit(BME280::TempUnit_Celsius);
  BME280::PresUnit presUnit(BME280::PresUnit_Pa);
  bme.read(pres, temp, hum, tempUnit, presUnit);
  client->print("Temp: ");
  client->print(temp);
  client->print(" *C");
  client->print("\tHumidity: ");
  client->print(hum);
  client->print(" %RH");
  client->print("\tPressure: ");
  client->print(pres);
  Pressure=(pres); // 
  client->print(" Pa");
  EnvironmentCalculations::AltitudeUnit envAltUnit  =  EnvironmentCalculations::AltitudeUnit_Meters;
  EnvironmentCalculations::TempUnit     envTempUnit =  EnvironmentCalculations::TempUnit_Celsius;
  Alt = EnvironmentCalculations::Altitude(pres, envAltUnit);
  dewPoint = EnvironmentCalculations::DewPoint(temp, hum, envTempUnit);
  seaLevel = EnvironmentCalculations::EquivalentSeaLevelPressure(Alt, temp, pres);
  // seaLevel = EnvironmentCalculations::SealevelAlitude(altitude, temp, pres); // Deprecated. See EquivalentSeaLevelPressure().

  client->print("\t\tAltitude: ");
  client->print(Alt);
  client->print(" m");
  client->print("\tDew point: ");
  client->print(dewPoint);
  client->print(" *C");
  client->print("\t Equivalent Sea Level Pressure: ");
  client->print(seaLevel);
  client->println(" Pa");
}
/////////////////////////////////////
/////////////////////////////////////
float julianDay()
{
  int a = year()/100;
  int b = a/4;
  int c = 2-a+b;
  long e = 365.25 * (year() + 4716);
  long f = 30.6001 * (month()+1);
  return (float)c + day() + (float)e + (float)f - 1524.5 + julianDayFraction();
}

float julianDayFraction()
{
  return ((float)(hour())/24.0f) + ((float)minute()/1440.0f) + ((float)second()/86400.0f);
}
unsigned long julianDayFractionAsLong(){
  return (unsigned long)((julianDayFraction() + .5) * 10000.0f) % 10000;
}   

/////////////////////////////////////

void GPS()
{ 
  Serial1.end();
  delay(1000);
  int counterGPS = 0; 
  Serial1.begin(9600); // connect gps sensor
  Serial.println();
  Serial.println("GPS Connection Opening..."); 
  delay(1000);
  while(1)
  {
   // Serial.print(".");
    if (Serial1.available())
    {
      // Serial.print("GPS Available");
      if (gps.encode(Serial1.read()))
      {
        gps.f_get_position(&lat,&lon);
        LAT=String(lat,6);
        LON=String(lon,6);
        gps.get_datetime(&data,&ttime);
        gps.hdop();  
        unsigned long age;
        int Year;
        byte Month, Day, Hour, Minute, Second;
        gps.crack_datetime(&Year, &Month, &Day, &Hour, &Minute, &Second, NULL, &age);
        if (age < 500) {
      // set the Time to the latest GPS reading
          setTime(Hour, Minute, Second, Day, Month, Year);
      // adjustTime(offset * SECS_PER_HOUR); 
        } 
        
        Sync = 1;
        
        if (lat!=0.00 && gps.f_altitude() < 50000.00) 
        {
          Serial.println("-----------------------");
          Serial.print("GPS: ");
      // Latitude
          Serial.print("Lat: ");
          Serial.print(lat,6);       
          Serial.print(",");
      // Longitude
          Serial.print("Lon: ");
          Serial.print(lon,6); 
          Serial.print(",");
      // Serial.print(gps.altitude());
          Serial.print("Alt: ");
          Serial.print(gps.f_altitude()); 
          Serial.print(",");
          Serial.print(data);
          Serial.print(",");
          Serial.print(ttime);
          Serial.print(",");
          Serial.print(gps.satellites());  
          Serial.print(",");
          Serial.println(gps.hdop());
          Serial.println("GPS Connection Closed");
          break;
        }    
      }
      else
      counterGPS++;
      if (counterGPS >= 10000)
      {
        Serial.println("GPS Data NOT AVAILABLE");
        Sync = 0;
        Serial.println(" ****************    W A R N I N G - Check GPS Connection ");     
        break;
      }
    }   
  }
}

void postFloatValue (float measurement, int digits, String sensorId) {
  //convert Float to String 
  char obs[10];
  dtostrf(measurement, 5, digits, obs);
  //Json erstellen
  String jsonValue = "{\"value\":";
  jsonValue += obs;
  jsonValue += "}";
  //Connect to OSeM Server and perfrom POST Operation 
  Serial.println("-------------------------------------");
  Serial.print("Connecting to OSeM Server...");
  if (client.connect(serverOSeM, 80)) {
    Serial.println("OSeM Server connected!");
    Serial.println("-------------------------------------");
    //build HTTP Header
    client.print("POST /boxes/"); client.print(SENSEBOX_ID); client.print("/"); client.print(sensorId); client.println(" HTTP/1.1");
    client.print("Host:");
    client.println(serverOSeM);
    client.println("Content-Type: application/json");
    client.println("Connection: close");
    client.print("Content-Length: "); client.println(jsonValue.length());
    client.println();
    //send Data
    Serial.println("OSeM Server Data Upload!");
    client.println(jsonValue);
    Serial.println("-------------------------------------");
  } else {
    Serial.println("OSeM Server connection failed!");
    Serial.println("-------------------------------------");
  }
  //Server Answer in the serial Monitor
 waitForServerResponse();
}

void waitForServerResponse () {
  //output of incoming Byte
  boolean repeat = true;
  do {
    if (client.available()) {
      char c = client.read();
      Serial.print(c);
    }
    //end connection
    if (!client.connected()) {
      Serial.println();
      Serial.println("--------------");
      Serial.println("OSeM Server Disconnected.");
      Serial.println("--------------");
      client.stop();
      repeat = false;
    }
  } while (repeat);
}

 
